<template>
    <div>
        <breadcrumb-component title="Clientes" :pages="breadPages"/>

        <panel-component title="Detalhes do produto">

            <div class="col-md-12">
                <h2><i class="fa fa-list-alt"></i> Dados gerais</h2>
            </div>

            <div class="col-md-9">
                <div class="col-md-9">
                    <label>Nome:</label> {{product.nome}}
                </div>

                <div class="col-md-3">
                    <label>Código interno:</label> {{product.codigo_interno}}
                </div>

                <div class="col-md-3">
                    <label>Código de barras:</label> {{product.codigo_barras}}
                </div>

                <div class="col-md-3">
                    <label>Categoria:</label> {{product.product_category.name}}
                </div>

                <div class="col-md-3">
                    <label>Movimenta estoque?</label> {{product.movimenta_estoque | filterBoolean}}
                </div>

                <div class="col-md-3">
                    <label>Habilitar nota fiscal?</label> {{product.emitir_nf | filterBoolean}}
                </div>

                <div class="col-md-3">
                    <label>Possui variações?</label> {{product.possui_variacao | filterBoolean}}
                </div>

                <div class="col-md-3">
                    <label>Produto ativo?</label> {{product.ativo | filterBoolean}}
                </div>

                <div class="col-md-3">
                    <label>Comissão:</label> {{product.comissao + '%'}}
                </div>

                <div class="col-md-3">
                    <label>Possui juros?</label> {{product.possui_juros | filterBoolean}}
                </div>

                <div class="col-md-3">
                    <label>Juros ao mês:</label> {{product.juros + '%'}}
                </div>

                <div class="col-md-3">
                    <label>Unidade de medida:</label> {{product.unity.sigla | uppercase}}
                </div>
            </div>

            <div class="col-md-3 text-center">
                <div v-if="product.imagem">
                    <div class="col-md-12">
                        <img :src="[`/storage/tenants/${tenant.uuid}/products/${product.imagem}`]"
                             class="img-thumbnail image-preview">
                    </div>
                </div>
                <div class="col-md-12" v-else>
                    <img src="https://www.freeiconspng.com/uploads/no-image-icon-6.png"
                         alt="" class="img-thumbnail image-preview">
                </div>
            </div>

            <div class="hr-line-dashed col-sm-12"></div>
            <div class="col-md-12">
                <h2><i class="fa fa-info-circle"></i> Detalhes</h2>
            </div>

            <div class="col-md-3">
                <label>Peso (Kg):</label> {{product.peso}}
            </div>

            <div class="col-md-3">
                <label>Largura (m):</label> {{product.largura}}
            </div>

            <div class="col-md-3">
                <label>Altura (m):</label> {{product.altura}}
            </div>

            <div class="col-md-3">
                <label>Cumprimento (m):</label> {{product.cumprimento}}
            </div>

            <div class="col-md-12">
                <label>Observações:</label> {{product.observacao}}
            </div>

            <div class="hr-line-dashed col-sm-12"></div>
            <div class="col-md-12">
                <h2><i class="fa fa-cubes"></i> Valores / Estoque</h2>
            </div>

            <div v-for="grid in product.product_grids" class="label-form col-md-12">
                <div class="col-md-3">
                    <label>Valor de custo:</label>
                    {{grid.valor_custo | currency('R$', 2, {decimalSeparator: ',', thousandsSeparator: '.'})}}
                </div>

                <div class="col-md-3">
                    <label>Despesas:</label>
                    {{grid.valor_despesas | currency('R$', 2, {decimalSeparator: ',', thousandsSeparator: '.'})}}
                </div>

                <div class="col-md-3">
                    <label>Custo final:</label>
                    {{grid.valor_custo_final | currency('R$', 2, {decimalSeparator: ',', thousandsSeparator: '.'})}}
                </div>

                <div class="col-md-3">
                    <label>Valor venda:</label>
                    {{grid.valor_venda | currency('R$', 2, {decimalSeparator: ',', thousandsSeparator: '.'})}}
                </div>

                <div class="col-md-3" v-if="product.possui_variacao">
                    <label>Código identificação:</label> {{grid.codigo_identificacao}}
                </div>

                <div class="col-md-3">
                    <label>Lucro utilizado:</label> {{grid.porcentagem_lucro + '%'}}
                </div>

                <div class="col-md-3">
                    <label>Estoque minimo:</label> {{grid.estoque_minimo}}
                </div>

                <div class="col-md-3">
                    <label>Estoque maximo:</label> {{grid.estoque_maximo}}
                </div>

                <div class="col-md-3">
                    <label>Estoque atual:</label> {{grid.estoque_atual}}
                </div>

                <div v-for="variation in grid.variations">
                    <div class="col-md-3">
                        <label>{{variation.grid.name}}:</label> {{variation.name}}
                    </div>
                </div>

            </div>

            <div class="hr-line-dashed col-sm-12"></div>
            <div class="col-md-12">
                <h2><i class="fa fa-truck"></i> Fornecedor</h2>
            </div>

            <div class="col-md-3">
                <label>Nome:</label> {{product.provider.name ? product.provider.name : ''}}
            </div>

            <div class="hr-line-dashed col-md-12"></div>
            <div class="col-md-12">
                <button class="btn btn-white" type="button" @click.prevent="backPage">
                    <i class="fa fa-reply"></i> Voltar
                </button>
            </div>

        </panel-component>
    </div>
</template>

<script>
    export default {
        props: {
            id: {
                require: true,
            }
        },
        data() {
            return {
                product: {
                    product_category: {name: ''},
                    unity: {sigla: ''},
                    provider: {name: ''},
                },
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'products', name: 'Gerenciar Produtos', active: false},
                    {link: 'products.detail', name: 'Detalhe', active: true},
                ],
            }
        },

        created() {
            this.$store.dispatch('loadProduct', this.id)
                .then(response => {
                    this.product = response
                    if (this.product.provider == null) {
                        this.product.provider = {name: ''}
                    }
                })
                .catch(() => {
                    this.$snotify.error('Produto não encontrado', '404')
                    this.$router.push({name: 'products'})
                })
        },

        computed: {
            tenant() {
                return this.$store.state.auth.data.tenant
            },
        },

        methods: {
            backPage() {
                this.$router.push({name: 'products'})
            }
        }

    }
</script>

<style scoped="">
    .image-preview {
        margin-bottom: 10px;
        width: 170px;
        height: 170px;
    }
</style>